//GLSL shader which compute diffuse shading
//light position set in DiffuseShader.cpp
//ZJW 2/2010

//global variable that rarely change
varying vec3 normal;
varying vec3 vertex_to_light;
varying vec3 vertex_to_light2;
varying vec3 viewVec;

//uniform sampler2D rock2norm;
//uniform sampler2D decal;
//uniform vec3 LightPos;
float power = 1.3;
float diffuseVar = .25;

void main()
{
	//normalize the interpolated normal and light
	vec3 normalVec = normalize(normal);

	//has no camera transform on light fine for this example
	vec3 lightVec = normalize(vertex_to_light);

	//calculate the diffuse contribution
	float diffuse = clamp(dot(lightVec, normalVec), 0.0, 1.0);

	//blue diffuse material
	//const vec4 diffuseMaterial = vec4(0.2, 0.2, 0.8, 1.0);

	//red diffuse material
	//const vec4 diffuseMaterial = vec4(0.8, 0.2, 0.2, 1.0);

	/*now add a specular contribution */

        //reflect vector                                               //new
        vec3 reflected = normalize(reflect(-lightVec, normalVec));

	//blue specular material
	//vec4 specularMaterial = vec4(0.8, 0.8, 0.4, 1.0);

	//red specular material
	//vec4 specularMaterial = vec4(0.4, 0.8, 0.8, 1.0);

	//calculate the specular contribution
	float specular = clamp(dot(viewVec, reflected), 0.0, 1.0);
        //float specular = max(dot(viewVec, reflected), 0.0);

        //light 2

	//has no camera transform on light fine for this example
	vec3 lightVec2 = normalize(vertex_to_light2);
	//calculate the diffuse contribution
	float diffuse2 = clamp(dot(lightVec2, normalVec), 0.0, 1.0);
        //reflect vector                                               //new
        vec3 reflected2 = normalize(reflect(-lightVec2, normalVec));
        float specular2 = max(dot(viewVec, reflected2), 0.0);


        //final outcome

	//combine terms to make color
	//gl_FragColor = diffuse*gl_FrontMaterial.diffuse + diffuseVar*gl_FrontMaterial.diffuse + pow(specular,power)*gl_FrontMaterial.specular;
        gl_FragColor = diffuse*gl_FrontMaterial.diffuse + diffuseVar*gl_FrontMaterial.diffuse + pow(specular,power)*gl_FrontMaterial.specular +
                       diffuse2*gl_FrontMaterial.diffuse + diffuseVar*gl_FrontMaterial.diffuse + pow(specular2,power)*gl_FrontMaterial.specular;
	
}
